/* $Id: entry.S,v 1.1 2000/11/11 09:02:33 honda Exp $
 *
 * dve68k-stub.c
 *
 * This is originally based on an m68k software stub written by Glenn
 * Engel at HP.
 *
 * Modifications for the uITRON4.0 specification OS "TOPPERS" by Shinya Honda
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License.  See the file "COPYING.LIB" in the main
 * directory of this archive for more details.
 *
 */
	
	.text
	.globl start
start:		
	.long  0x3700 
	.long  start_1  
start_1:	
	/*
	 *  åݥ󥿤 __stack ˽
	 */
	ori.w   #0x3700,%sr	          /* super,disable interrupts */
	move.l #_stack,%sp
	ori.w   #0x2700,%sr	          /* super,disable interrupts */
	move.l #_stack-0x1000,%sp


	/*
	 *  bss򥯥ꥢ롥
	 */
	move.l #__bss_start, %a0
	move.l #__bss_end, %d0
	sub.l %a0, %d0
	jbeq 2f
1:
	clr.b (%a0)+
	dbra %d0, 1b
	clr.w %d0
	subq.l #1, %d0
	jbcc 1b

	/*
	 *  data
	 *
	 *  __idata_start  __idata_end ޤǤ__data_start ʹߤ
	 *  ԡ롥
	 */
2:
	move.l #__idata_end, %d0
	sub.l #__idata_start, %d0
	jbls 4f
	move.l #__idata_start, %a0
	move.l #__data_start, %a1
3:
	move.b (%a0)+, (%a1)+
	dbra %d0,3b
	clr.w %d0
	subq.l #1, %d0
	jbcc 3b



	/*
	 *  init_hardware ƤӽФ
	 *
	 *  åȥϡɥ˰¸ɬפʽ
	 *  ϡinit_hardware ȤؿѰդ롥
	 */
4:
	move.l #init_hardware, %a0 
	jsr (%a0) 


	/*
	 *  ᥤ롼ư롥
	 */
5:
	jmp start_gdbstub



	.text
	.globl return_to_super
return_to_super:
        move.l   registers+60,%sp /* get new stack pointer */        
        move.l   lastFrame,%a0    /* get last frame info  */              
        bra      return_to_any

	.globl return_to_user
return_to_user:
        move.l   registers+60,%a0 /* get usp */                          
        move.l   %a0,%usp         /* set usp */				
        move.l   superStack,%sp   /* get original stack pointer */        

return_to_any:
        move.l  lastFrame,%a0    /* get last frame info  */              
        move.l  (%a0)+,lastFrame /* link in previous frame     */        
        addq.l  #8,%a0           /* skip over pc, vector#*/              
        move.w  (%a0)+,%d0       /* get # of words in cpu frame */       
        add.w   %d0,%a0          /* point to end of data        */       
        add.w   %d0,%a0          /* point to end of data        */       
        move.l  %a0,%a1                                                   
        subql   #1,%d0                                                   
copyUserLoop:                                                               
        move.w  -(%a1),-(%sp)                                               
        dbf     %d0,copyUserLoop
	cinva   %bc
	move.l  cach_state,%d0
	movec.l %d0,%cacr	                                             
        movem.l registers,%d0-%d7/%a0-%a6
	move.l  #0x00,in_stub	
        rte
	
	.text
	.globl debug_level7
debug_level7:
	move.l  %d0,-(%sp)
	move.l  %a0,-(%sp)	
	move.l  #0xfff4405c,%a0   
	ori.l   #0x40000000,(%a0)
	move.l  in_stub,%d0
	cmp.l   #0x1,%d0   
	jbeq    already7   
        move.l  (%sp)+,%a0		
        move.l  (%sp)+,%d0	
        bra     catchException
already7:
        move.l  (%sp)+,%a0			
	move.l   (%sp)+,%d0
	rte


/* This function is called when a 68020 exception occurs.  It saves
 * all the cpu and fpcp regs in the _registers array, creates a frame on a
 * linked list of frames which has the cpu and fpcp stack frames needed
 * to properly restore the context of these processors, and invokes
 * an exception handler (remcom_handler).
 *
 * stack on entry:                       stack on exit:
 *   N bytes of junk                     exception # MSWord
 *   Exception Format Word               exception # MSWord
 *   Program counter LSWord              
 *   Program counter MSWord             
 *   Status Register                    
 *                                       
 *                                       
 */
	.text
	.globl catchException
catchException:
	move.l  #0x01,in_stub
	ori.w   #0x2700,%sr	          /* super,disable interrupts */
        move.ml  %d0-%d7/%a0-%a6,registers /* save registers     */
	cinva   %bc
	movec.l %cacr,%d0
	move.l  %d0,cach_state
	move.l  #0x0,%d0
	movec.l %d0,%cacr
	move.l	lastFrame,%a0	          /* last frame pointer */
	lea     registers,%a5             /* get address of registers */
        move.w   (%sp),%d1                 /* get status register      */
        move.w   %d1,66(%a5)               /* save sr		      */	
	move.l   2(%sp),%a4                /* save pc in a4 for later use  */
        move.l   %a4,68(%a5)               /* save pc in _regisers[]       */

#
# figure out how many bytes in the stack frame
	move.w  6(%sp),%d0	/* get '020 exception format	*/
        move.w  %d0,%d2         /* make a copy of format word   */
        andi.w  #0xf000,%d0     /* mask off format type         */
        rol.w   #5,%d0          /* rotate into the low byte *2  */
        lea     exceptionSize,%a1   
        add.w   %d0,%a1         /* index into the table         */
	move.w  (%a1),%d0       /* get number of words in frame */
        move.w  %d0,%d3         /* save it                      */
        sub.w   %d0,%a0		/* adjust save pointer          */
        sub.w   %d0,%a0		/* adjust save pointer(bytes)   */
	move.l  %a0,%a1         /* copy save pointer            */
	subql   #1,%d0          /* predecrement loop counter    */

# copy the frame
saveFrameLoop:
	move.w  	(%sp)+,(%a1)+
	dbf     %d0,saveFrameLoop


# now that the stack has been clenaed,
# save the a7 in use at time of exception
        move.l  %sp,superStack  /* save supervisor sp           */
        andi.w  #0x2000,%d1     /* were we in supervisor mode ? */
        beq     userMode       
        move.l  %a7,60(%a5)     /* save a7                  */
        bra     a7saveDone
userMode:  
	move.l   %usp,%a1    	
        move.l   %a1,60(%a5)     /* save user stack pointer	*/
a7saveDone:

# save size of frame
        move.w   %d3,-(%a0)

# compute exception number
	and.l   #0xfff,%d2   	/* mask off vector offset	*/
	lsr.w   #2,%d2   	/* divide by 4 to get vect num	*/
        move.l  %d2,-(%a0)      /* save it                      */
#
# save pc causing exception
        move.l   %a4,-(%a0)
#
# save old frame link and set the new value
	move.l	lastFrame,%a1	/* last frame pointer */
	move.l   %a1,-(%a0)	/* save pointer to prev frame	*/
        move.l   %a0,lastFrame
	move.l   #_stack,%sp       /* move to remcom stack area  */	
        move.l   %d2,-(%sp)	     /* push exception num           */
	jbsr    handle_exception   /* this never returns */	
        clr.l   (%sp)                /* replace exception num parm with frame ptr */
        jbsr     returnFromException   /* jbsr, but never returns */


